<!-- 
-------------------------------------------------------------------------------
MIT License
   
Copyright (c) 2024 University College Cork (UCC)
    
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:
    
The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.
   
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
     
      
SPDX-License-Identifier: MIT
      
Contributors:
   Panagiotis Kyziropoulos - Author
   Dimitrios Bikoulis - Co-author
    
------------------------------------------------------------------------------- 
-->
<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Datamite Projects</title>
  <link rel="stylesheet" href="{{ url_for('static', filename='css/basicbar.css') }}">
  <link rel="stylesheet" href="{{ url_for('static', filename='css/headers.css') }}">
  <link rel="stylesheet" href="{{ url_for('static', filename='css/mainstyle.css') }}">
  <script src="https://cdn.plot.ly/plotly-latest.min.js"></script> 
  <script src="{{ url_for('static', filename='js/script.js') }}" defer></script>
</head>

<body>
  <header>
    <div class="logo">
      <a href="/"> 
        <!-- "../public/images/logo-datamite-color-horizontal.png" -->
        <img src="{{ url_for('static', filename='images/logo-datamite-color-horizontal.png') }}"  alt="Logo">
      </a>
    </div>
    <h1>Data Bias Tool</h1>
  </header>

  <div class="sidenav">
    <ul>
      {% for project in projects %}
        <li><a href="/api/{{ project.id }}">{{ project.name }}</a></li>
      {% endfor %}
    </ul>
    <div class="sidenav-logo">
      <img src="{{ url_for('static', filename='images/logo-datamite-color-vertical.png') }}" alt="Sidenav Logo">
    </div>
    <div class="container">
      <p>Message:</p>
      <div id="responseDiv">Response will be displayed here.</div>
    </div>
  </div>


  <div class="main-content">

    <h2> {{ selected.name }} </h2>
    <div class="section" id="generalinfo">
      <h3>Description</h3>
      <p> {{ data.Description }}</p>
    </div>
    
    <div class="section" id="results">
      <h3>Results</h3>
      {% if data["Results"] == {} %}
        <p> There are not results available yet</p>
        <button onclick="getstats();" id="statsButton">Get Stats</button>
      {% else %}
        <div class="section" id="stats">
          {% if data["Results"]["stats"] == {} %}
            <p>Compute something for moving on</p>

          {% else %} <!-- Display "stats" results if available-->
            <table border="1">
              <thead>
                  <tr>
                      <th>Attribute</th>
                      <th>Type</th>
                      <th>Unique values</th>
                  </tr>
              </thead>
              <tbody>
                  {% for entry in data["Results"]["stats"] %}
                  <tr>
                      <td>{{ entry[0] }}</td>
                      <td>{{ entry[1] }}</td>
                      <td>{{ entry[2] }}</td>
                  </tr>
                  {% endfor %}
              </tbody>
            </table>
          {% endif %}
        </div> <!-- id="stats"-->
        
        <div class="section" id="props">
          <h4>Proportions</h4>
          <p> Complete description</p>
          <label for="props-dropdown">Choose an Target attribute from the columns:</label>
          <select id="props-selector">
            {% for entry in data["Results"]["stats"] %}
            <option value="{{ entry[0] }}">{{ entry[0] }}</option>
            {% endfor %}
          </select>
          <button onclick="submitProps();" type="button" id="props-submit">Submit</button>
          {% if data["Results"]["props"] is not defined or data["Results"]["props"] == None or data["Results"]["props"] =='' %}
            <p> Click the button for the first round of results </p>
          {% else %}
            <div id="myDiv" style="width:600px;height:400px;"></div>
          {% endif%}
        </div> <!-- id="props"-->

        <div class="section" id="distros">
          <h4>Target distribution by sensitive group </h4>
          <p> Complete description</p>
          <label for="distros-selector-1">Choose an Target attribute from the columns</label>
          <select id="distros-selector-1">
            {% for entry in data["Results"]["stats"] %}
            <option value="{{ entry[0] }}">{{ entry[0] }}</option>
            {% endfor %}
          </select>
          <label for="distros-selector-2"> and a sensitive attribute </label>
          <select id="distros-selector-2">
            {% for entry in data["Results"]["stats"] %}
            <option value="{{ entry[0] }}">{{ entry[0] }}</option>
            {% endfor %}
          </select>
          <button onclick="submitDistros();" type="button" id="distros-submit">Submit</button>
          {% if data["Results"]["distros"] is not defined or data["Results"]["distros"] == None or data["Results"]["distros"] =='' %}
            <p> Make first computation </p>
          {% else %}
            <div id="myDiv2" style="width:600px;height:400px;"></div>        
          {% endif%}
        </div> <!-- id="distros"-->

        <div class="section" id="metrics">
          <h4>Fairness metrics </h4>
          <p> Complete description</p>
          <label for="metrics-selector-1"> Choose target </label>
          <select id="metrics-selector-1">
            {% for entry in data["Results"]["stats"] %}
            <option value="{{ entry[0] }}">{{ entry[0] }}</option>
            {% endfor %}
          </select>
          <label for="options1">with positive outcome</label>
          <select id="options1">
            <option value="">Select an option</option>
          </select>
          <label for="metrics-selector-2"> and sensitive attribute </label>
          <select id="metrics-selector-2">
            {% for entry in data["Results"]["stats"] %}
            <option value="{{ entry[0] }}">{{ entry[0] }}</option>
            {% endfor %}
          </select>
          <label for="options2">with privileged group</label>
          <select id="options2">
            <option value="">Select an option</option>
          </select>
          <label for="metrics-selector-3"> and metric </label>
          <select id="metrics-selector-3">
            <option value="Statistical Parity">Statistical Parity</option>
            <option value="Disparate Impact">Disparate Impact</option>
          </select>
          <button type="button" onclick="submitMetricComp()" id="metrics-submit">Submit</button>
          {% if data["Results"]["metrics"] is not defined or data["Results"]["metrics"] == None or data["Results"]["metrics"] =='' %}
            <p> Make first computation </p>
          {% else %} <!-- Printing results for metrics -->
            <h3>{{ data["Results"]["metrics"][0] }}: </h3>
            <table border="1">
              <thead>
                  <tr>
                      <th>Sensitive Group</th>
                      <th>Metric Value</th>
                  </tr>
              </thead>
              <tbody>
                  {% for entry in data["Results"]["metrics"][5] %}
                  <tr>
                      <td>{{ entry[0] }}</td>
                      <td>{{ entry[1] }}</td>
                  </tr>
                  {% endfor %}
              </tbody>
            </table>
            <p>The metric was computed using the attribute "{{ data["Results"]["metrics"][1] }}" as target and "{{ data["Results"]["metrics"][2] }} " as the sensitive attribute, for which it was considered that "{{ data["Results"]["metrics"][3] }}" is the privileged group regarding the positive outcome "{{ data["Results"]["metrics"][4] }}" of the target attribute. </p>
          {% endif%}
        </div> <!-- id="metrics"-->

      {% endif %}
    </div> <!-- id="results" -->
  </div> <!-- class="main-content" -->


  <script>
    document.getElementById('metrics-selector-1').addEventListener('change',function(){
      var make = document.getElementById('metrics-selector-1').value;
      console.log(make)
      var aname = '{{ selected.id }}';
      const optionsDropdown = document.getElementById('options1');
      optionsDropdown.innerHTML = '<option value="">Select an option</option>';
      console.log("project_id:",aname)
      const requestData = {
          'project_id': aname,
          'attribute': make
      };
      fetch('/api/get_options', {
          method: 'POST', 
          headers: {
              'Content-Type': 'application/json'
          },
          body: JSON.stringify(requestData) // Send the request data as JSON
      })
      .then(response => response.json())
      .then(data => {
          data.forEach(option => {
              const optionElement = document.createElement('option');
              optionElement.value = option;
              optionElement.textContent = option;
              optionsDropdown.appendChild(optionElement);
          });
      })
      .catch((error) => {
        console.error('Error:', error);
      });
    })

    document.getElementById('metrics-selector-2').addEventListener('change',function(){
      var make = document.getElementById('metrics-selector-2').value;
      console.log(make)
      var aname = '{{ selected.id }}';
      const optionsDropdown2 = document.getElementById('options2');
      optionsDropdown2.innerHTML = '<option value="">Select an option</option>';
      console.log("project_id:",aname)
      const requestData = {
          'project_id': aname,
          'attribute': make
      };
      fetch('/api/get_options', {
          method: 'POST', 
          headers: {
              'Content-Type': 'application/json'
          },
          body: JSON.stringify(requestData) // Send the request data as JSON
      })
      .then(response => response.json())
      .then(data => {
          data.forEach(option => {
              const optionElement = document.createElement('option');
              optionElement.value = option;
              optionElement.textContent = option;
              optionsDropdown2.appendChild(optionElement);
          });
      })
      .catch((error) => {
        console.error('Error:', error);
      });
    })

    function getstats(){
      var aname = '{{ selected.id }}';
          console.log("project_id:",aname)
          const requestData = {
              'project_id': aname
          };
          fetch('/api/give_stats', {
              method: 'POST', 
              headers: {
                  'Content-Type': 'application/json'
              },
              body: JSON.stringify(requestData) // Send the request data as JSON
          })
          .then(response => response.json())
          .then(data => {
            alert(data.message);
          })
          .catch((error) => {
            console.error('Error:', error);
          });
    }

   // Fetch the give_proportions api
    function submitProps() {
      var aname = '{{ selected.id }}';
      const selectedOption = document.getElementById('props-selector').value;
      const requestData = {
                'project_id': aname,
                'attribute': selectedOption
            };    
      fetch('/api/give_proportions', {
        method: 'POST',
        headers: {
          'Content-Type': 'application/json',
        },
        body: JSON.stringify(requestData),
      })
      .then(response => {
        if (response.ok) {
          return response.text(); // Parse the response text
        } else {
          // Handle non-successful response status
          console.error('Failed to send data:', response.status, response.statusText);
          throw new Error('Network response was not ok');
        }
      })
      .then(responseText => {
        // Save the response text to local storage
        localStorage.setItem('responseText', responseText);
        // Refresh the page
        window.location.reload();
      })
      .catch((error) => {
        console.error('Error:', error);
      });
    }

    // Function to load the response text from local storage
    function loadResponseText() {
      const responseText = localStorage.getItem('responseText');
      if (responseText) {
        const dictionary = JSON.parse(responseText);
        const newText = dictionary.message
        document.getElementById('responseDiv').innerText = newText;
      }
    }

    // Load the response text when the page loads
    window.onload = loadResponseText;

    // Fetch the distbygroup api
    function submitDistros() {
    var aname = '{{ selected.id }}';
    const selectedOption1 = document.getElementById('distros-selector-1').value;
    const selectedOption2 = document.getElementById('distros-selector-2').value;
    const requestData = {
              'project_id': aname,
              'class': selectedOption1,
              'sensitive': selectedOption2
            };    
    fetch('/api/distbygroup', {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
      },
      body: JSON.stringify(requestData),
    })
    .then(response => {
        if (response.ok) {
          return response.text(); // Parse the response text
        } else {
          // Handle non-successful response status
          console.error('Failed to send data:', response.status, response.statusText);
          throw new Error('Network response was not ok');
        }
      })
      .then(responseText => {
        // Save the response text to local storage
        localStorage.setItem('responseText', responseText);
        // Refresh the page
        window.location.reload();
      })
    .catch((error) => {
      console.error('Error:', error);
    });
  }

    // Fetch the distbygroup api
    function submitMetricComp() {
      var aname = '{{ selected.id }}';
      const selectedOption1 = document.getElementById('metrics-selector-1').value;
      const selectedValue1 = document.getElementById('options1').value;
      const selectedOption2 = document.getElementById('metrics-selector-2').value;
      const selectedValue2 = document.getElementById('options2').value;
      const selectedMetric = document.getElementById('metrics-selector-3').value;

      const requestData = {
                'project_id': aname,
                'class': selectedOption1,
                'positive': selectedValue1,
                'sensitive': selectedOption2,
                'priviledged':selectedValue2,
                'metric':selectedMetric
              };    
      fetch('/api/metrics', {
        method: 'POST',
        headers: {
          'Content-Type': 'application/json',
        },
        body: JSON.stringify(requestData),
      })
      .then(response => {
          if (response.ok) {
            return response.text(); // Parse the response text
          } else {
            // Handle non-successful response status
            console.error('Failed to send data:', response.status, response.statusText);
            throw new Error('Network response was not ok');
          }
        })
        .then(responseText => {
          // Save the response text to local storage
          localStorage.setItem('responseText', responseText);
          // Refresh the page
          window.location.reload();
        })
      .catch((error) => {
        console.error('Error:', error);
      });
  }

    // PIE CHART plot
    var results = JSON.parse('{{ data|tojson|safe }}');
    var propResults = results["Results"]["props"] 
    // Get the name of the displayed attribute
    var varName = propResults[0]
    var dataplot = propResults[1]

    // Get the keys of the dictionary
    var keys = Object.keys(dataplot);
    // Get the values of the dictionary
    var values = Object.values(dataplot);
    
    // Convert each string to a float
    var floatList = values.map(function(stringValue) {
      return parseFloat(stringValue);
    });
    // Multiply each element of the list by the constant using map
    var constant = 100;
    var multipliedList = floatList.map(function(floatValue) {
      return floatValue * constant;
    });
    var data = [{
        values: multipliedList,
        labels: keys,
        hole: .4,
        type: 'pie'
    }];
    var layout = {
      title: 'Proportions for the selected column',
      annotations: [
        {
          font: {
            size: 16
          },
          showarrow: false,
          text: varName,
        }
      ],
      height: 400,
      width: 600,
      showlegend: false,
    };
    Plotly.newPlot('myDiv', data, layout);

    // BAR CHART script
    var results = JSON.parse('{{ data|tojson|safe }}');
    var distroResults = results["Results"]["distros"] 
    // Get the name of the displayed attribute
    var className = distroResults[0]
    var sensiName = distroResults[1]
    var dataplot = distroResults[2]

    var keys = Object.keys(dataplot);
    var values = Object.values(dataplot);
    var subkeys = Object.keys(values[0]);
    var numtraces = subkeys.lenght;
    tracesCont = []
    singleTrace = []
    for (var key in values[0]) {
      if (values[0].hasOwnProperty(key)) {
        for (var greatKey in values) {
          if (values.hasOwnProperty(greatKey)) {
            singleTrace.push(values[greatKey][key]);
          }
        }
        tracesCont.push(singleTrace);
        singleTrace = [];
      }
    }
    var traces = [];
    for (var index = 0; index < subkeys.length; index++) {
        traces.push({ x: keys, name: subkeys[index], y: tracesCont[index], type:'bar' });
    }
    let layTitle = 'Target ' + className +' per sensitive group '+sensiName
    var layout = {
      title: layTitle, 
      barmode: 'group'
    };
    Plotly.newPlot('myDiv2', traces, layout);

  </script>
</body>
</html>
